Index: /TOOLS/MOSAIX/nemo.py
===================================================================
--- /TOOLS/MOSAIX/nemo.py	(revision 6665)
+++ /TOOLS/MOSAIX/nemo.py	(revision 6666)
@@ -1593,133 +2247,183 @@
     The correction is needed with cartopy <= 0.20
     It seems that version 0.21 will correct the bug (https://github.com/SciTools/cartopy/pull/1926)
+    Later note : the bug is still present in Cartopy 0.22
 
     Inputs :
-       u, v : eastward/nothward components
+       u, v : eastward/northward components
        lat  : latitude of the point (degrees north)
 
-    Outputs : 
+    Outputs :
        modified eastward/nothward components to have correct polar projections in cartopy
     '''
     uv = np.sqrt (u*u + v*v)           # Original modulus
     zu = u
-    zv = v * np.cos (rad*lat)
+    zv = v * np.cos (RAD*lat)
     zz = np.sqrt ( zu*zu + zv*zv )     # Corrected modulus
-    uc = zu*uv/zz ; vc = zv*uv/zz      # Final corrected values
+    uc = zu*uv/zz
+    vc = zv*uv/zz      # Final corrected values
     return uc, vc
 
-def msf (v_e1v_e3v, lat1d, depthw) :
-    '''
-    Computes the meridonal stream function
-    First input is meridional_velocity*e1v*e3v
-    '''
-    @numba.jit(forceobj=True)
-    def iin (tab, dim) :
-        '''
-        Integrate from the bottom
-        '''
-        result = tab * 0.0
-        nlen = len(tab.coords[dim])
-        for jn in np.arange (nlen-2, 0, -1) :
-            result [{dim:jn}] = result [{dim:jn+1}] - tab [{dim:jn}]
-        result = result.where (result !=0, np.nan)
-        return result
-    
-    zomsf = iin ((v_e1v_e3v).sum (dim='x', keep_attrs=True)*1E-6, dim='depthv')
-    zomsf = zomsf.assign_coords ( {'depthv':depthw.values, 'y':lat1d})
-    zomsf = zomsf.rename ( {'depthv':'depthw', 'y':'lat'})
+def norm_uv (u, v) :
+    '''Returns norm of a 2 components vector
+    '''
+    return np.sqrt (u*u + v*v)
+
+def normalize_uv (u, v) :
+    '''Normalizes 2 components vector
+    '''
+    uv = norm_uv (u, v)
+    return u/uv, v/uv
+
+def msf (vv, e1v_e3v, plat1d, depthw) :
+    '''Computes the meridonal stream function
+
+    vv : meridional_velocity
+    e1v_e3v : prodcut of scale factors e1v*e3v
+    '''
+
+    v_e1v_e3v = vv * e1v_e3v
+    v_e1v_e3v.attrs = vv.attrs
+
+    ax = __find_axis__ (v_e1v_e3v, 'x')[0]
+    az = __find_axis__ (v_e1v_e3v, 'z')[0]
+    if az == 'olevel' :
+        new_az = 'olevel'
+    else :
+        new_az = 'depthw'
+
+    zomsf = -v_e1v_e3v.cumsum ( dim=az, keep_attrs=True).sum (dim=ax, keep_attrs=True)*1.E-6
+    zomsf = zomsf - zomsf.isel ( { az:-1} )
+
+    ay = __find_axis__ (zomsf, 'y' )[0]
+    zomsf = zomsf.assign_coords ( {az:depthw.values, ay:plat1d.values})
+
+    zomsf = zomsf.rename ( {ay:'lat'})
+    if az != new_az :
+        zomsf = zomsf.rename ( {az:new_az} )
+    zomsf.attrs['standard_name'] = 'Meridional stream function'
     zomsf.attrs['long_name'] = 'Meridional stream function'
-
     zomsf.attrs['units'] = 'Sv'
-    zomsf.depthw.attrs=depthw.attrs
-    zomsf.lat.attrs=lat1d.attrs
-        
+    zomsf[new_az].attrs  = depthw.attrs
+    zomsf.lat.attrs=plat1d.attrs
+
     return zomsf
 
-def bsf (u_e2u_e3u, mask, nperio=None, bsf0=None ) :
-    '''
-    Computes the barotropic stream function
-    First input is zonal_velocity*e2u*e3u
-    bsf0 is the point with bsf=0 (ex: bsf0={'x':5, 'y':120} )
-    '''
-    @numba.jit(forceobj=True)
-    def iin (tab, dim) :
-        '''
-        Integrate from the south
-        '''
-        result = tab * 0.0
-        nlen = len(tab.coords[dim])
-        for jn in np.arange (3, nlen) :
-            result [{dim:jn}] = result [{dim:jn-1}] + tab [{dim:jn}]
-        return result
-    
-    bsf = iin ((u_e2u_e3u).sum(dim='depthu', keep_attrs=True)*1E-6, dim='y')
-    bsf.attrs = u_e2u_e3u.attrs
-    if bsf0 != None :
-        bsf = bsf - bsf.isel (bsf0)
-       
-    bsf = bsf.where (mask !=0, np.nan)
-    bsf.attrs['long_name'] = 'Barotropic stream function'
-    bsf.attrs['units'] = 'Sv'
-    bsf = lbc (bsf, nperio=nperio, cd_type='F')
-       
-    return bsf
-
-def namelist_read (ref=None, cfg=None, out='dict', flat=False, verbose=False) :
-    '''
-    Read NEMO namelist(s) and return either a dictionnary or an xarray dataset
-
-    ref : file with reference namelist, or a f90nml.namelist.Namelist object
-    cfg : file with config namelist, or a f90nml.namelist.Namelist object
-    At least one namelist neaded
-
-    out: 
+def bsf (uu, e2u_e3u, mask, nperio=None, bsf0=None ) :
+    '''Computes the barotropic stream function
+
+    uu      : zonal_velocity
+    e2u_e3u : product of scales factor e2u*e3u
+    bsf0    : the point with bsf=0
+    (ex: bsf0={'x':3, 'y':120} for orca2,
+         bsf0={'x':5, 'y':300} for eORCA1
+    '''
+    u_e2u_e3u       = uu * e2u_e3u
+    u_e2u_e3u.attrs = uu.attrs
+
+    ay = __find_axis__ (u_e2u_e3u, 'y')[0]
+    az = __find_axis__ (u_e2u_e3u, 'z')[0]
+
+    zbsf = -u_e2u_e3u.cumsum ( dim=ay, keep_attrs=True )
+    zbsf = zbsf.sum (dim=az, keep_attrs=True)*1.E-6
+
+    if bsf0 :
+        zbsf = zbsf - zbsf.isel (bsf0)
+
+    zbsf = zbsf.where (mask !=0, np.nan)
+    zbsf.attrs.update (uu.attrs)
+    zbsf.attrs['standard_name'] = 'barotropic_stream_function'
+    zbsf.attrs['long_name']     = 'Barotropic stream function'
+    zbsf.attrs['units']         = 'Sv'
+    zbsf = lbc (zbsf, nperio=nperio, cd_type='F')
+
+    return zbsf
+
+if f90nml :
+    def namelist_read (ref=None, cfg=None, out='dict', flat=False, verbose=False) :
+        '''Read NEMO namelist(s) and return either a dictionnary or an xarray dataset
+
+        ref : file with reference namelist, or a f90nml.namelist.Namelist object
+        cfg : file with config namelist, or a f90nml.namelist.Namelist object
+        At least one namelist neaded
+
+        out:
         'dict' to return a dictonnary
         'xr'   to return an xarray dataset
-    flat : only for dict output. Output a flat dictionnary with all values.
-    
-    '''
-
-    if ref != None :
-        if isinstance (ref, str) : nml_ref = f90nml.read (ref)
-        if isinstance (ref, f90nml.namelist.Namelist) : nml_ref = ref
-        
-    if cfg != None :
-        if isinstance (cfg, str) : nml_cfg = f90nml.read (cfg)
-        if isinstance (cfg, f90nml.namelist.Namelist) : nml_cfg = cfg
-    
-    if out == 'dict' : dict_namelist = {}
-    if out == 'xr'   : xr_namelist = xr.Dataset ()
-
-    list_nml = [] ; list_comment = []
-
-    if ref != None :
-        list_nml.append (nml_ref) ; list_comment.append ('ref')
-    if cfg != None :
-        list_nml.append (nml_cfg) ; list_comment.append ('cfg')
-
-    for nml, comment in zip (list_nml, list_comment) :
-        if verbose : print (comment)
-        if flat and out =='dict' :
-            for nam in nml.keys () :
-                if verbose : print (nam)
-                for value in nml[nam] :
-                     if out == 'dict' : dict_namelist[value] = nml[nam][value]
-                     if verbose : print (nam, ':', value, ':', nml[nam][value])
-        else :
-            for nam in nml.keys () :
-                if verbose : print (nam)
-                if out == 'dict' :
-                    if nam not in dict_namelist.keys () : dict_namelist[nam] = {}
-                for value in nml[nam] :
-                    if out == 'dict' : dict_namelist[nam][value] = nml[nam][value]
-                    if out == 'xr'   : xr_namelist[value] = nml[nam][value]
-                    if verbose : print (nam, ':', value, ':', nml[nam][value])
-
-    if out == 'dict' : return dict_namelist
-    if out == 'xr'   : return xr_namelist
-
+        flat : only for dict output. Output a flat dictionary with all values.
+
+        '''
+        if ref :
+            if isinstance (ref, str) :
+                nml_ref = f90nml.read (ref)
+            if isinstance (ref, f90nml.namelist.Namelist) :
+                nml_ref = ref
+
+        if cfg :
+            if isinstance (cfg, str) :
+                nml_cfg = f90nml.read (cfg)
+            if isinstance (cfg, f90nml.namelist.Namelist) :
+                nml_cfg = cfg
+
+        if out == 'dict' :
+            dict_namelist = {}
+        if out == 'xr'   :
+            xr_namelist = xr.Dataset ()
+
+        list_nml     = []
+        list_comment = []
+
+        if ref :
+            list_nml.append (nml_ref)
+            list_comment.append ('ref')
+        if cfg :
+            list_nml.append (nml_cfg)
+            list_comment.append ('cfg')
+
+        for nml, comment in zip (list_nml, list_comment) :
+            if verbose :
+                print (comment)
+            if flat and out =='dict' :
+                for nam in nml.keys () :
+                    if verbose :
+                        print (nam)
+                    for value in nml[nam] :
+                        if out == 'dict' :
+                            dict_namelist[value] = nml[nam][value]
+                        if verbose :
+                            print (nam, ':', value, ':', nml[nam][value])
+            else :
+                for nam in nml.keys () :
+                    if verbose :
+                        print (nam)
+                    if out == 'dict' :
+                        if nam not in dict_namelist.keys () :
+                            dict_namelist[nam] = {}
+                    for value in nml[nam] :
+                        if out == 'dict' :
+                            dict_namelist[nam][value] = nml[nam][value]
+                        if out == 'xr'   :
+                            xr_namelist[value] = nml[nam][value]
+                        if verbose :
+                            print (nam, ':', value, ':', nml[nam][value])
+
+        if out == 'dict' :
+            return dict_namelist
+        if out == 'xr'   :
+            return xr_namelist
+else :
+     def namelist_read (ref=None, cfg=None, out='dict', flat=False, verbose=False) :
+        '''Shadow version of namelist read, when f90nm module was not found
+
+        namelist_read : 
+        Read NEMO namelist(s) and return either a dictionnary or an xarray dataset
+        '''
+        print ( 'Error : module f90nml not found' )
+        print ( 'Cannot call namelist_read' )
+        print ( 'Call parameters where : ')
+        print ( f'{err=} {ref=} {cfg=} {out=} {flat=} {verbose=}' )
 
 def fill_closed_seas (imask, nperio=None,  cd_type='T') :
     '''Fill closed seas with image processing library
+
     imask : mask, 1 on ocean, 0 on land
     '''
@@ -1730,4 +2434,118 @@
 
     return imask_filled
+
+# ======================================================
+# Sea water state function parameters from NEMO code
+
+RDELTAS = 32.
+R1_S0   = 0.875/35.16504
+R1_T0   = 1./40.
+R1_Z0   = 1.e-4
+
+EOS000 =  8.0189615746e+02
+EOS100 =  8.6672408165e+02
+EOS200 = -1.7864682637e+03
+EOS300 =  2.0375295546e+03
+EOS400 = -1.2849161071e+03
+EOS500 =  4.3227585684e+02
+EOS600 = -6.0579916612e+01
+EOS010 =  2.6010145068e+01
+EOS110 = -6.5281885265e+01
+EOS210 =  8.1770425108e+01
+EOS310 = -5.6888046321e+01
+EOS410 =  1.7681814114e+01
+EOS510 = -1.9193502195
+EOS020 = -3.7074170417e+01
+EOS120 =  6.1548258127e+01
+EOS220 = -6.0362551501e+01
+EOS320 =  2.9130021253e+01
+EOS420 = -5.4723692739
+EOS030 =  2.1661789529e+01
+EOS130 = -3.3449108469e+01
+EOS230 =  1.9717078466e+01
+EOS330 = -3.1742946532
+EOS040 = -8.3627885467
+EOS140 =  1.1311538584e+01
+EOS240 = -5.3563304045
+EOS050 =  5.4048723791e-01
+EOS150 =  4.8169980163e-01
+EOS060 = -1.9083568888e-01
+EOS001 =  1.9681925209e+01
+EOS101 = -4.2549998214e+01
+EOS201 =  5.0774768218e+01
+EOS301 = -3.0938076334e+01
+EOS401 =  6.6051753097
+EOS011 = -1.3336301113e+01
+EOS111 = -4.4870114575
+EOS211 =  5.0042598061
+EOS311 = -6.5399043664e-01
+EOS021 =  6.7080479603
+EOS121 =  3.5063081279
+EOS221 = -1.8795372996
+EOS031 = -2.4649669534
+EOS131 = -5.5077101279e-01
+EOS041 =  5.5927935970e-01
+EOS002 =  2.0660924175
+EOS102 = -4.9527603989
+EOS202 =  2.5019633244
+EOS012 =  2.0564311499
+EOS112 = -2.1311365518e-01
+EOS022 = -1.2419983026
+EOS003 = -2.3342758797e-02
+EOS103 = -1.8507636718e-02
+EOS013 =  3.7969820455e-01
+
+def rhop ( ptemp, psal ) :
+    '''Returns potential density referenced to surface
+
+    Computation from NEMO code
+    '''
+    zt      = ptemp * R1_T0                                  # Temperature (Â°C)
+    zs      = np.sqrt ( np.abs( psal + RDELTAS ) * R1_S0 )   # Square root of salinity (PSS)
+    #
+    prhop = (
+      (((((EOS060*zt
+         + EOS150*zs     + EOS050)*zt
+         + (EOS240*zs    + EOS140)*zs + EOS040)*zt
+         + ((EOS330*zs   + EOS230)*zs + EOS130)*zs + EOS030)*zt
+         + (((EOS420*zs  + EOS320)*zs + EOS220)*zs + EOS120)*zs + EOS020)*zt
+         + ((((EOS510*zs + EOS410)*zs + EOS310)*zs + EOS210)*zs + EOS110)*zs + EOS010)*zt
+         + (((((EOS600*zs+ EOS500)*zs + EOS400)*zs + EOS300)*zs + EOS200)*zs + EOS100)*zs + EOS000 )
+    #
+    return prhop
+
+def rho ( pdep, ptemp, psal ) :
+    '''Returns in situ density
+
+    Computation from NEMO code
+    '''
+    zh      = pdep  * R1_Z0                                  # Depth (m)
+    zt      = ptemp * R1_T0                                  # Temperature (Â°C)
+    zs      = np.sqrt ( np.abs( psal + RDELTAS ) * R1_S0 )   # Square root salinity (PSS)
+    #
+    zn3 = EOS013*zt + EOS103*zs+EOS003
+    #
+    zn2 = (EOS022*zt + EOS112*zs+EOS012)*zt + (EOS202*zs+EOS102)*zs+EOS002
+    #
+    zn1 = (
+      (((EOS041*zt
+       + EOS131*zs   + EOS031)*zt
+       + (EOS221*zs  + EOS121)*zs + EOS021)*zt
+       + ((EOS311*zs  + EOS211)*zs + EOS111)*zs + EOS011)*zt
+       + (((EOS401*zs + EOS301)*zs + EOS201)*zs + EOS101)*zs + EOS001 )
+    #
+    zn0 = (
+      (((((EOS060*zt
+         + EOS150*zs      + EOS050)*zt
+         + (EOS240*zs     + EOS140)*zs + EOS040)*zt
+         + ((EOS330*zs    + EOS230)*zs + EOS130)*zs + EOS030)*zt
+         + (((EOS420*zs   + EOS320)*zs + EOS220)*zs + EOS120)*zs + EOS020)*zt
+         + ((((EOS510*zs  + EOS410)*zs + EOS310)*zs + EOS210)*zs + EOS110)*zs + EOS010)*zt
+         + (((((EOS600*zs + EOS500)*zs + EOS400)*zs + EOS300)*zs +
+                                       EOS200)*zs + EOS100)*zs + EOS000 )
+    #
+    prho  = ( ( zn3 * zh + zn2 ) * zh + zn1 ) * zh + zn0
+    #
+    return prho
 
 ## ===========================================================================
@@ -1737,44 +2555,44 @@
 ## ===========================================================================
 
-def __is_orca_north_fold__ ( Xtest, cname_long='T' ) :
-    '''
-    Ported (pirated !!?) from Sosie
-
-    Tell if there is a 2/point band overlaping folding at the north pole typical of the ORCA grid
-
-    0 => not an orca grid (or unknown one)
-    4 => North fold T-point pivot (ex: ORCA2)
-    6 => North fold F-point pivot (ex: ORCA1)
-
-    We need all this 'cname_long' stuff because with our method, there is a
-    confusion between "Grid_U with T-fold" and "Grid_V with F-fold"
-    => so knowing the name of the longitude array (as in namelist, and hence as
-    in netcdf file) might help taking the righ decision !!! UGLY!!!
-    => not implemented yet
-    '''
-    
-    ifld_nord =  0 ; cgrd_type = 'X'
-    ny, nx = Xtest.shape[-2:]
-
-    if ny > 3 : # (case if called with a 1D array, ignoring...)
-        if ( Xtest [ny-1, 1:nx//2-1] - Xtest [ny-3, nx-1:nx-nx//2+1:-1] ).sum() == 0. :
-          ifld_nord = 4 ; cgrd_type = 'T' # T-pivot, grid_T      
-
-        if ( Xtest [ny-1, 1:nx//2-1] - Xtest [ny-3, nx-2:nx-nx//2  :-1] ).sum() == 0. :
-            if cnlon == 'U' : ifld_nord = 4 ;  cgrd_type = 'U' # T-pivot, grid_T
-                ## LOLO: PROBLEM == 6, V !!!
-
-        if ( Xtest [ny-1, 1:nx//2-1] - Xtest [ny-3, nx-1:nx-nx//2+1:-1] ).sum() == 0. :
-            ifld_nord = 4 ; cgrd_type = 'V' # T-pivot, grid_V
-
-        if ( Xtest [ny-1, 1:nx//2-1] - Xtest [ny-2, nx-1-1:nx-nx//2:-1] ).sum() == 0. :
-            ifld_nord = 6 ; cgrd_type = 'T'# F-pivot, grid_T
-
-        if ( Xtest [ny-1, 1:nx//2-1] - Xtest [ny-1, nx-1:nx-nx//2-1:-1] ).sum() == 0. :
-            ifld_nord = 6 ;  cgrd_type = 'U' # F-pivot, grid_U
-
-        if ( Xtest [ny-1, 1:nx//2-1] - Xtest [ny-3, nx-2:nx-nx//2  :-1] ).sum() == 0. :
-            if cnlon == 'V' : ifld_nord = 6 ; cgrd_type = 'V' # F-pivot, grid_V
-                ## LOLO: PROBLEM == 4, U !!!
-
-    return ifld_nord, cgrd_type
+# def __is_orca_north_fold__ ( Xtest, cname_long='T' ) :
+#     '''
+#     Ported (pirated !!?) from Sosie
+
+#     Tell if there is a 2/point band overlaping folding at the north pole typical of the ORCA grid
+
+#     0 => not an orca grid (or unknown one)
+#     4 => North fold T-point pivot (ex: ORCA2)
+#     6 => North fold F-point pivot (ex: ORCA1)
+
+#     We need all this 'cname_long' stuff because with our method, there is a
+#     confusion between "Grid_U with T-fold" and "Grid_V with F-fold"
+#     => so knowing the name of the longitude array (as in namelist, and hence as
+#     in netcdf file) might help taking the righ decision !!! UGLY!!!
+#     => not implemented yet
+#     '''
+
+#     ifld_nord =  0 ; cgrd_type = 'X'
+#     ny, nx = Xtest.shape[-2:]
+
+#     if ny > 3 : # (case if called with a 1D array, ignoring...)
+#         if ( Xtest [ny-1, 1:nx//2-1] - Xtest [ny-3, nx-1:nx-nx//2+1:-1] ).sum() == 0. :
+#           ifld_nord = 4 ; cgrd_type = 'T' # T-pivot, grid_T
+
+#         if ( Xtest [ny-1, 1:nx//2-1] - Xtest [ny-3, nx-2:nx-nx//2  :-1] ).sum() == 0. :
+#             if cnlon == 'U' : ifld_nord = 4 ;  cgrd_type = 'U' # T-pivot, grid_T
+#                 ## LOLO: PROBLEM == 6, V !!!
+
+#         if ( Xtest [ny-1, 1:nx//2-1] - Xtest [ny-3, nx-1:nx-nx//2+1:-1] ).sum() == 0. :
+#             ifld_nord = 4 ; cgrd_type = 'V' # T-pivot, grid_V
+
+#         if ( Xtest [ny-1, 1:nx//2-1] - Xtest [ny-2, nx-1-1:nx-nx//2:-1] ).sum() == 0. :
+#             ifld_nord = 6 ; cgrd_type = 'T'# F-pivot, grid_T
+
+#         if ( Xtest [ny-1, 1:nx//2-1] - Xtest [ny-1, nx-1:nx-nx//2-1:-1] ).sum() == 0. :
+#             ifld_nord = 6 ;  cgrd_type = 'U' # F-pivot, grid_U
+
+#         if ( Xtest [ny-1, 1:nx//2-1] - Xtest [ny-3, nx-2:nx-nx//2  :-1] ).sum() == 0. :
+#             if cnlon == 'V' : ifld_nord = 6 ; cgrd_type = 'V' # F-pivot, grid_V
+#                 ## LOLO: PROBLEM == 4, U !!!
+
+#     return ifld_nord, cgrd_type
Index: /TOOLS/MOSAIX/update_xml.py
===================================================================
--- /TOOLS/MOSAIX/update_xml.py	(revision 6665)
+++ /TOOLS/MOSAIX/update_xml.py	(revision 6666)
@@ -26,11 +26,25 @@
 ##  software by incorrectly or partially configured
 ##
-##
+'''
+Python script used to perform on the fly
+editing of xml files. Used by `CreateWeights.bash`. More
+information with `python update_xml.py -h`.
+
 ## SVN information
-__Author__   = "$Author$"
-__Date__     = "$Date$"
-__Revision__ = "$Revision$"
-__Id__       = "$Id$"
-__HeadURL    = "$HeadURL$"
+Author   = "$Author$"
+Date     = "$Date$"
+Revision = "$Revision$"
+Id       = "$Id$"
+HeadURL  = "$HeadURL$"
+'''
+
+## SVN information
+__SVN__ = ({
+    'Author'   : "$Author$",
+    'Date'     : "$Date$",
+    'Revision' : "$Revision$",
+    'Id'       : "$Id$",
+    'HeadURL'  : "$HeadURL$",
+    })
 
 # python update_xml.py -i ~/Unix/TOOLS/MOSAIX/iodef_atm_to_oce.xml -o essai.xml -n 'context[@id="interpol_read"]/file_definition/file[@id="file_src"]/field[@id="mask_src"]' -k name=Bidon
@@ -41,12 +55,8 @@
 #
 import xml.etree.ElementTree
-import argparse, sys, textwrap, shlex
-    
+import argparse, sys, shlex
+
 # Check version of Python
 Version = sys.version_info
-if Version < (2,7,0) :
-  sys.stderr.write ( "You need python 2.7 or later to run this script\n" )
-  sys.stderr.write ( "Present version is: " + str(Version[0]) + "." + str(Version[1]) + "." + str(Version[2]) + "\n" )
-  sys.exit (1)
 
 ## ============================================================================
@@ -56,6 +66,6 @@
     '''Concatenate some elements of the list of strings when needed'''
     zlist = list_str.copy () ; list_new = []
-    while ( len (zlist) > 0 ) :
-        arg = zlist.pop (0)    
+    while len (zlist) > 0 :
+        arg = zlist.pop (0)
         if arg[0] == '"' :
             for arg2 in zlist.copy () :
@@ -66,22 +76,22 @@
         list_new.append (arg)
     return list_new
-  
-def UpdateNode (iodef, Node, Text=None, Key=None) :
+
+def UpdateNode (piodef, pNode, pText=None, pKey=None) :
     '''Update an xml node'''
     # Remove whitespaces at both ends
-    Node = Node.rstrip().lstrip()
+    zNode = pNode.rstrip().lstrip()
 
     ## Find node
-    nodeList = iodef.findall (Node)
+    nodeList = piodef.findall (zNode)
 
     ## Check that one and only one node is found
     if len (nodeList) == 0 :
         print ( "Error : node not found" )
-        print ( "Node  : ", Node )
+        print ( "Node  : ", zNode )
         sys.exit (1)
-    
+
     if len (nodeList) > 1 :
         print ( "Error : " + len (nodeList)+" occurences of node found in file" )
-        print ( "Node  : ", Node )
+        print ( "Node  : ", zNode )
         sys.exit (2)
 
@@ -89,20 +99,20 @@
     elem = nodeList[0]
 
-    if Text != None :
-        if Verbose : print ( 'Node:', Node, ' -- Text:', Text  )
+    if pText is not None :
+        if Verbose : print ( 'Node:', zNode, ' -- Text:', pText  )
         if Debug :
             print ( 'Attributes of node: ' + str (elem.attrib) )
             print ( 'Text              : ' + str (elem.text)   )
-        elem.text = Text
-
-    if Key != None :
-      
+        elem.text = pText
+
+    if pKey is not None :
+
         # Check the syntax
-        if not '=' in Key :
+        if not '=' in pKey :
             print ( 'Key syntax error. Correct syntax is -k Key=Value' )
             sys.exit (-1)
         else :
-            KeyName, Value = Key.split ('=')
-            if Verbose : print ( 'Node:', Node, ' -- Key:', Key )
+            KeyName, Value = pKey.split ('=')
+            if Verbose : print ( 'Node:', zNode, ' -- Key:', pKey )
             # To do : check that KeyName exist (it is added if not : do we want that ?)
             if Debug :
@@ -110,5 +120,5 @@
             elem.attrib.update ( { KeyName:Value } )
 
-    return iodef
+    return piodef
 
 ## ============================================================================
@@ -118,15 +128,15 @@
 # The first step in using the argparse is creating an ArgumentParser object:
 parser = argparse.ArgumentParser (description = """
-Examples with the modification on the command line : 
+Examples with the modification on the command line :
      python %(prog)s -i iodef.xml -n 'context[@id="interpol_run"]/file_definition/file[@id="file_src"]/field[@id="mask_source"]' -k name -v maskutil_T
      python %(prog)s -i iodef.xml -n 'context[@id="interpol_run"]/file_definition/file[@id="dia"]/variable[@name="dest_grid"]'   -t dstDomainType
 
-Usage with a command file : 
+Usage with a command file :
      python %(prog)s -i iodef.xml -c commands.txt
-   
-Syntax in the command file : removes the quote around the node description : 
+
+Syntax in the command file : removes the quote around the node description :
 -n context[@id="interpol_run"]/file_definition/file[@id="dia"]/variable[@name="dest_grid"]   -t dstDomainType
 
-   """ + "SVN : " + __Revision__, formatter_class=argparse.RawDescriptionHelpFormatter, epilog='-------- This is the end of the help message --------')
+   """ + "SVN : " + __SVN__['Revision'], formatter_class=argparse.RawDescriptionHelpFormatter, epilog='-------- This is the end of the help message --------')
 
 # Adding arguments
@@ -155,16 +165,16 @@
 Key         = myargs.key
 Text        = myargs.text
-    
-if FileCommand != None : 
-    if ( Node != None or Key != None or Text != None ) :
+
+if FileCommand is not None :
+    if ( Node is not None or Key is not None or Text is not None ) :
         print ('Error : when a command file is specified, options -k|--key, -n|--node are unused' )
         exit (-2)
-    
-if FileOut == None : FileOut = FileIn
-    
+
+if FileOut is None : FileOut = FileIn
+
 ## Get XML tree from input file
 iodef = xml.etree.ElementTree.parse ( FileIn )
 
-if FileCommand == None :
+if FileCommand is None :
     ## Only one node to modify
     iodef = UpdateNode (iodef, Node, Key, Text)
@@ -172,15 +182,15 @@
 else :
     ## Read a list of modification commands in a command file
-    fic = open (FileCommand, 'r')
-    lignes = fic.readlines()
+    fic = open (FileCommand, 'r', encoding='utf-8')
+    lignes = fic.readlines ()
 
     for nn, ligne in enumerate (lignes) :
         ligne = ligne.strip ().split ('#')[0] # Remove leading and trailing blanks, and trailing comments
         if Debug : print (nn+1, ':', type (ligne) , ':', len (ligne) , ':', ligne, ':')
-        if ligne == '' or ligne == None or len(ligne) == 0 or ligne[0] == '#' :
+        if ligne == '' or ligne is None or len(ligne) == 0 or ligne[0] == '#' :
             if Debug : print ('Skips blank or comment line')
-        else : 
+        else :
             list_args = shlex.split (ligne)
-        
+
             if Debug :
                 print ( '{:3d} : '.format(nn+1), end='')
@@ -193,6 +203,6 @@
             Text     = myargs_ligne.text
 
-            UpdateNode (iodef, Node, Text, Key)
-    
+            iodef = UpdateNode (iodef, Node, Text, Key)
+
 ## Writes XML tree to file
 iodef.write ( FileOut )
@@ -201,5 +211,5 @@
 if Debug : print ('This is the end')
 #sys.exit (0)
-    
+
 ### ===========================================================================
 ###
@@ -207,3 +217,2 @@
 ###
 ### ===========================================================================
-
